(* ⪨  p饣 RANDOM'a *)
(* (c) by Valery Isaev 2:5047/16.0 (my b0ss) *)

unit Rand;

interface

type

  PRandomRecord = ^TRandomRecord;
  TRandomRecord = record
    Item: integer;
    NextItem: PRandomRecord;
  end;

function StartRandom(from_i, to_i: integer): boolean;
procedure StopRandom;
function GetRandom: integer;
procedure StepRandom;

var

  StartItem,OldItem,CurItem: PRandomRecord;

const

  VStopRandom: boolean = true;

implementation

function StartRandom(from_i, to_i: integer): boolean;
var
  i, io: integer;
begin
  if not VStopRandom then begin
    StartRandom := false;
    Exit;
  end;
  io := from_i;
  GetMem(StartItem, sizeof(TRandomRecord));
  CurItem := StartItem;
  StartItem^.Item := io;
  StartItem^.NextItem := nil;
  for i := from_i to to_i - 1 do begin
    inc(io);
    OldItem := CurItem;
    GetMem(CurItem,sizeof(TRandomRecord));
    CurItem^.Item := io;
    CurItem^.NextItem := nil;
    OldItem^.NextItem := CurItem;
  end;
  CurItem^.NextItem := StartItem;
  StartRandom := true;
  VStopRandom := false;
end;

procedure StopRandom;
var
  OldItem: PRandomRecord;
begin
  if VStopRandom then Exit;
  OldItem := CurItem;
  CurItem := CurItem^.NextItem;
  OldItem^.NextItem := nil;
  while CurItem^.NextItem <> nil do begin
    OldItem := CurItem;
    CurItem := CurItem^.NextItem;
    FreeMem(OldItem, sizeof(TRandomRecord));
  end;
  FreeMem(CurItem, sizeof(TRandomRecord));
  VStopRandom := true;
  StartItem := nil;
end;

function GetRandom: integer;
begin
  GetRandom := -1;
  if StartItem = nil then Exit;
  GetRandom := CurItem^.Item;
  OldItem := CurItem;
  while CurItem^.NextItem <> OldItem do CurItem := CurItem^.NextItem;
  CurItem^.NextItem := OldItem^.NextItem;
  if CurItem = OldItem then
    StopRandom
  else
    FreeMem(OldItem, sizeof(TRandomRecord));
end;

procedure StepRandom;
var i: integer;
begin
  Randomize;
  if CurItem^.NextItem = nil then StopRandom;
  for i := Random(100) to 100 do CurItem := CurItem^.NextItem;
end;

end.
